package rhu_Download;

use strict;

use rhu_RPM;

# -- use object-oriented FTP module :
use Net::FTP;

# -----------------------------------------------------------------------------

my $site_0 = { NAME => "updates.redhat.com",
               DIR  => "/7.2/en/os/i386/",
               LOGIN => "anonymous",
               PASSWD => "simon.hood\@umist.ac.uk"};

#my $site_1 = { NAME => "updates.redhat.com",
#               DIR  => "/7.1/en/os/i386/",
#               LOGIN => "anonymous",
#               PASSWD => "simon.hood\@umist.ac.uk"};

# -----------------------------------------------------------------------------
# -- NEW :
# -----------------------------------------------------------------------------

sub new_rec() {

    my $class   = shift;
    my $site    = shift;
    my $file    = shift;
    my $dir     = shift;
    my $default = shift;

    my $self = { };
    bless($self, $class);

    &rec_download_2($self, $site, $file, $dir, $default);

    return 1;
  }


# -----------------------------------------------------------------------------
# -- PRIVATE :
# -----------------------------------------------------------------------------

sub rec_download_2() {

  my $self    = shift;
  my $site    = shift;
  my $file    = shift;
  my $dir     = shift;
  my $default = shift;

    # -- loop till our user gives us a sensible answer to our question :
    while (1) {

        # -- our questions with helpful info :
        print "\n    Download $file ? [$default] ";

        my $response = <STDIN>;
        chop($response);

        if (($response eq "y") || ($response eq "")) {

            print "\n    Connecting to site: $site->{NAME}...";
            my $ftp = Net::FTP->new($site->{NAME});
  
            $ftp->login($site->{LOGIN}, $site->{PASSWD});
            $ftp->cwd($site->{DIR});
            $ftp->binary();

            print "\n    Downloading to $dir: $file...";
            $ftp->get($file, "$dir/$file")
                || die "\n    Can't get file: $file\n";

            $ftp->quit;

            my $rpm = rhu_RPM->new_file("$dir/$file");

            print "\n\n        (Downloaded RPM: ";
            print $rpm->{NAME}, " v", $rpm->{VERSION};
            print "\n            Requires:";

            foreach (@{$rpm->{REQUIREDRPMS}}) {
                print "\n                $_->{NAME} v$_->{VERSREL}";
                print " ...checking... ";

####################################    
                my $installed = 0;
              
                # -- is it installed ?

                my $ins_rpm = rhu_RPM->new_insrpm($rpm->{NAME});
                if ($ins_rpm) { $installed = 1; }

                # -- if installed and version/release ok then skip :

                if (    ($installed) 
                     && (    ($ins_rpm->{VERSION} > $_->{VERSION})
                          || (    ($ins_rpm->{VERSION} = $_->{VERSION})
                               && ($ins_rpm->{RELEASE} >= $_->{RELEASE})))) {
                    print "ok";
                    next;
                  }

                # -- if installed say it's too old, else say it's 
                #    not installed :
 
                if ($installed) {
                    print "\n                *** vers/rel too old :  ";
                        print "got " . $ins_rpm->{VERSION} . "-" 
                                     . $ins_rpm->{RELEASE} . " "
                            . "req " . $_->{VERSREL};

                        print "\n    ...searching for newer one...";
                  }
                else {
                    print "\n                *** not installed";
                  }

                # -- if can find version/release required :

		if (my $found = &find_rpm($_)) {
                    &rec_download($self, 
                                  $found->{SITE}, $found->{RPM}, 
                                  $dir, "y");
                  }
                else {
                    print "\n                *** could NOT find newer";
                  }
####################################
              }
            print "\n         )";

            last;
          }
        elsif ($response eq "n") {
            last;
          }
      }

    return 1;
  }




sub rec_download() {

  my $self    = shift;
  my $site    = shift;
  my $file    = shift;
  my $dir     = shift;
  my $default = shift;

    # -- loop till our user gives us a sensible answer to our question :
    while (1) {

        # -- our questions with helpful info :
        print "\n    Download $file ? [$default] ";

        my $response = <STDIN>;
        chop($response);

        if (($response eq "y") || ($response eq "")) {

            print "\n    Connecting to site: $site->{NAME}...";
            my $ftp = Net::FTP->new($site->{NAME});
  
            $ftp->login($site->{LOGIN}, $site->{PASSWD});
            $ftp->cwd($site->{DIR});
            $ftp->binary();

            print "\n    Downloading to $dir: $file...";
            $ftp->get($file, "$dir/$file")
                || die "\n    Can't get file: $file\n";

            $ftp->quit;

            my $rpm = rhu_RPM->new_file("$dir/$file");

            print "\n\n        (Downloaded RPM: ";
            print $rpm->{NAME}, " v", $rpm->{VERSION};
            print "\n            Requires:";

            foreach (@{$rpm->{REQUIREDRPMS}}) {
                print "\n                $_->{NAME} v$_->{VERSREL}";
                print " ...checking... ";
                  
                if (my $ins_rpm = rhu_RPM->new_insrpm($rpm->{NAME})) {

                    if (    ($ins_rpm->{VERSION} < $_->{VERSION})
                         || (    ($ins_rpm->{VERSION} = $_->{VERSION})
                              && ($ins_rpm->{RELEASE} < $_->{RELEASE}))
                       ) {

                        print "*** vers/rel too old :  ";
                        print "got " . $ins_rpm->{VERSION} . "-" 
                                     . $ins_rpm->{RELEASE} . " "
                            . "req " . $_->{VERSREL};

                        print "\n    ...searching for newer one...";
			if (my $found = &find_rpm($_)) {
                            &rec_download($self, 
                                          $found->{SITE}, 
                                          $found->{RPM}, 
                                          $dir, "y");
                          }
                        else {
                            print "*** could NOT find newer";
                          }
                      }
                    else {
                        print "ok";
                      }
                  }
                else {
                    print "*** not installed";
                    print "\n    ...searching for one...";
                    if (my $found = &find_rpm($_)) {
                        &rec_download($self, $found->{SITE}, $found->{RPM}, 
                                      $dir, "y");
                      }
                    else {
                        print "*** could NOT find one";
                      }
                  }
              }
            print "\n         )";

            last;
          }
        elsif ($response eq "n") {
            last;
          }
      }

    return 1;
  }



sub download() {

  my $self    = shift;
  my $site    = shift;
  my $file    = shift;
  my $dir     = shift;
  my $default = shift;

    # -- loop till our user gives us a sensible answer to our question :
    while (1) {

        # -- our questions with helpful info :
        print "\n     Download " . $file . "? [$default] ";

        my $response = <STDIN>;
        chop($response);

        if (($response eq "y") || ($response eq "")) {

            print "\n    Connecting to site: $site->{NAME}...";
            my $ftp = Net::FTP->new($site->{NAME});
  
            $ftp->login($site->{LOGIN}, $site->{PASSWD});
            $ftp->cwd($site->{DIR});
            $ftp->binary();

            print "\n    Downloading to $dir: $file...";
            $ftp->get($file, "$dir/$file")
                || die "\n    Can't get file: $file\n";

            $ftp->quit;

            my $rpm = rhu_RPM->new_file("$dir/$file");

            print "\n\n        (Downloaded RPM: ";
            print $rpm->{NAME}, " v", $rpm->{VERSION};
            print "\n            Requires:";

            foreach (@{$rpm->{REQUIREDRPMS}}) {
                print "\n                $_->{NAME} v$_->{VERSION}";
                print " ...checking... ";
                if (my $ins_rpm = rhu_RPM->new_insrpm($rpm->{NAME})) {
                    if ($ins_rpm->{VERSION} < $_->{VERSION}) {
                        print "version too old ***";
                      }
                    else {
                        print "ok";
                      }
                  }
                else {
                    print "not installed ***";
                  }
              }
            print "\n         )";

            last;
          }
        elsif ($response eq "n") {
            last;
          }
      }

    return 1;
  }


# -----------------------------------------------------------------------------
# -- TOOLKIT :
# -----------------------------------------------------------------------------

sub find_rpm() {

    my $wanted  = shift;
    my $name    = $wanted->{NAME};
    my $versrel = $wanted->{VERSREL};
    my $version = $wanted->{VERSION};
    my $release = $wanted->{RELEASE};

    my $found = { };

print "\n\n This is the find_rpm place-holder ...............";
print "\n $name";
print "\n $version";
print "\n $release";
print "\n\n";
exit; 

          # --- ftp://ftp.redhat.com
          # --- ftp://updates.redhat.com
          # --- http://rpmfind.net         ???

#    if () {
#        $found->{SITE} = ;
#        $found->{RPM}  = ;
#
#        return $found;
#      }
#    else {
#        return 0;
#      }
  }

# -----------------------------------------------------------------------------
1;
# -----------------------------------------------------------------------------
